=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2007-09-14 13:09:28 +0000
+++ annotate/gannotate.py	2007-09-14 15:56:39 +0000
@@ -50,7 +50,8 @@
         
         gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
 
-        self.connect("destroy", gtk.main_quit)
+        self.connect("delete-event", gtk.main_quit)
+        self.connect("key-press-event", self._on_key_pressed)
         
         self.set_icon(self.render_icon(gtk.STOCK_FIND, gtk.ICON_SIZE_BUTTON))
         self.annotate_colormap = AnnotateColorSaturation()
@@ -393,6 +394,22 @@
             if i + n >= row:
                 return j - i
 
+    def _on_key_pressed(self, widget, event):
+        """ Key press event handler. """
+        keyname = gtk.gdk.keyval_name(event.keyval)
+        func = getattr(self, '_on_key_press_' + keyname, None)
+        if func:
+            return func(event)
+
+    def _on_key_press_w(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            self.destroy()
+
+    def _on_key_press_q(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            gtk.main_quit()
+    
+
 
 
 class FakeRevision:

=== modified file 'tags.py'
--- tags.py	2007-09-14 13:09:28 +0000
+++ tags.py	2007-09-14 15:56:39 +0000
@@ -35,12 +35,10 @@
         """ Initialize the Tags window. """
         gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
 
-        self.connect("destroy", gtk.main_quit)
-        
         # Get arguments
         self.branch = branch
         self._parent = parent
-        
+
         # Create the widgets
         self._button_add = gtk.Button(stock=gtk.STOCK_ADD)
         self._button_remove = gtk.Button(stock=gtk.STOCK_REMOVE)
@@ -62,6 +60,7 @@
         self._button_refresh.connect('clicked', self._on_refresh_clicked)
         self._button_remove.connect('clicked', self._on_remove_clicked)
         self._treeview_tags.connect('cursor-changed', self._on_treeview_changed)
+        self.connect('key-press-event', self._on_key_pressed)
         if parent is None:
             self.connect('delete-event', gtk.main_quit)
         
@@ -179,6 +178,23 @@
         self.destroy()
         if self._parent is None:
             gtk.main_quit()
+
+    def _on_key_pressed(self, widget, event):
+        """ Key press event handler. """
+        keyname = gtk.gdk.keyval_name(event.keyval)
+        func = getattr(self, '_on_key_press_' + keyname, None)
+        if func:
+            return func(event)
+
+    def _on_key_press_w(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            self.destroy()
+            if self._parent is None:
+                gtk.main_quit()
+
+    def _on_key_press_q(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            gtk.main_quit()
     
     def _on_refresh_clicked(self, widget):
         """ Refresh button event handler. """

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-09-14 13:09:28 +0000
+++ viz/branchwin.py	2007-09-14 15:56:39 +0000
@@ -31,7 +31,7 @@
         self.set_border_width(0)
         self.set_title("bzrk")
 
-        self.connect("destroy", gtk.main_quit)
+        self.connect("delete-event", gtk.main_quit)
 
         # Use three-quarters of the screen by default
         screen = self.get_screen()
@@ -47,6 +47,8 @@
         self.accel_group = gtk.AccelGroup()
         self.add_accel_group(self.accel_group)
 
+        self.connect('key-press-event', self._on_key_pressed)
+
         self.construct()
 
     def construct(self):
@@ -202,6 +204,20 @@
         self.treeview.set_model(self.model)
         return False
     
+    def _on_key_pressed(self, widget, event):
+        """ Key press event handler. """
+        keyname = gtk.gdk.keyval_name(event.keyval)
+        func = getattr(self, '_on_key_press_' + keyname, None)
+        if func:
+            return func(event)
+
+    def _on_key_press_w(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            self.destroy()
+
+    def _on_key_press_q(self, event):
+        if event.state & gtk.gdk.CONTROL_MASK:
+            gtk.main_quit()
     
     def _treeview_cursor_cb(self, *args):
         """Callback for when the treeview cursor changes."""

